#!/usr/bin/python
import sys
sys.path.append('/usr/lib/python2.2')
print sys.path
from Blender import *
from string import *


namelist = {}

vrml_name = ascii_letters+'_'+digits
###GENERAL FUNCTIONS###

def averageValue(liste):
	c = 0
	sum = 0
	for v in liste:
		sum += v
		c += 1
	return sum/c

def getValues(string,number):
	values = []
	c = 0
	while c < number:
		f = findFloat(string)
		values.append(f)
		string = deleteString(string,f)
		c += 1
	return [string, values]

def killComments(string):
	pos = 0
	pos1 = -1
	pos2 = -1
	length = len(string)
	while pos < length:
		if string[pos] == '#':
			pos1 = pos
		if pos1 >= 0 and string[pos] == '\n':
			pos2 = pos
			pos = pos1-1
			string = string[:pos1]+string[pos2+1:]
			length = len(string)
			pos1 = -1
		pos += 1
	return string

def setNewName(oldname,newname):
	if oldname != newname:
		namelist[oldname]= newname

def getNewName(name):
	if namelist.keys().count(name):
		return namelist[name]
	return name

def deleteString(string, delete):
	poss = 0
	posd = 0
	firstpos = -1
	#print 'zu loeschender string', delete
	#raw_input()
	while 1:
		if len(delete) == 0:
			return string
		if string.find(delete) < 1:
			pass #print delete
			#print string.find(delete)
			#raw_input()
		#if poss == len(string):
			#print 'abbruch wegen laenge', poss, len(string)
			#break
		#print posd
		#print delete
		#print delete[posd]
		if string[poss]== delete[posd]:
			#print string[poss]
			#print delete
			if posd == 0:
				firstpos = poss
			posd += 1
			if posd == len(delete):
				#print 'string vorher', string
				#print 'geloeschter string' , string
				return string[:firstpos]+string[poss+1:]
		else:
			if posd > 0:
				poss = firstpos
				posd = 0
		poss +=1


###GENERAL FIND FUNCTIONS###

def findNode(string, brace):
	if brace == '}':
		brace2 = '{'
	if brace == ']':
		brace2 = '['
	position = 0
	for char in string:
		if char == brace2:
			#print char
			start = position
			end = getCloseBrace(string[position:], brace)+start
			key = findKeyword(string, position)
			#print key, string[end]
			return [start+1, end, key]							#the brace of the current keyword is at start, but no longer needed, so we move 1 pos ahead
		position += 1

def findKey(string):
	keys = []
	pos = 0
	start = -1
	end = -1
	keyletters = ascii_letters+'_-0123456789'
	for c in string:
		#print pos
		if keyletters.find(c) > -1:
			#print string[pos]
			if start < 0:
				start = pos
			if start > 0:
	 			end = pos+1
		if start >= 0 and end > 0 and keyletters.find(c) == -1:
			#print string
			return [string[start:end], end]
		pos += 1

def findBool(string, pos):
	bool = []
	startpos = pos
	start = -1
	end = -1
	while 1:
		#print pos
		if pos - startpos > 10:
			break
		if ascii_uppercase.find(string[pos]) > -1:
		#print string[pos]
			if start < 0:
				start = pos
			if start > 0:
	 			end = pos+1
		if start >= 0 and end > 0 and ascii_uppercase.find(string[pos]) == -1:
			#print string
			return [string[start:end],end]
		pos += 1

def findKeyword(string, position):						#search for a Keyword in a given string left of the given position
	#print 'searching for keyword...'						#position should be the position of a brace
	#raw_input()
	name = None
	usedef = None
	sname = None
	pos = position
	end = -1
	start = -1
	#print pos
	while pos > 0:
		#print pos
		if ascii_letters.find(string[pos]) > -1:
			#print string[pos]
			if end < 0:
				end = pos +1
		if ascii_letters.find(string[pos]) > -1:
			if end > 0:
			 start = pos
		if start >= 0 and end > 0 and ascii_letters.find(string[pos-1]) == -1:
			key = string[start:end]
			break
		else: pos -= 1
	#print 'key:', key
	pos -=1

	end = -1
	start = -1
	while pos > 0:
		if string[pos] == '{':
			break
		if vrml_name.find(string[pos]) > -1:
			if end < 0:
				end = pos +1
		if vrml_name.find(string[pos]) > -1:
			if end > 0:
			 start = pos
		if start >= 0 and end > 0 and vrml_name.find(string[pos]) == -1:
			name = string[start:end]
			break
		else: pos -= 1
	#print 'name:',name
	pos -=1

	end = -1
	start = -1
	while pos > 0:
		if string[pos] == '{':
			break
		if vrml_name.find(string[pos]) > -1:
			if end < 0:
				end = pos +1
		if vrml_name.find(string[pos]) > -1:
			if end > 0:
			 start = pos
		if start >= 0 and end > 0 and vrml_name.find(string[pos]) == -1:
			usedef = string[start:end]
			break
		else: pos -= 1
	#print 'usedef',usedef


	end = -1
	start = -1
	while pos > 0:
		if string[pos] == '{':
			break
		if vrml_name.find(string[pos]) > -1:
			if end < 0:
				end = pos +1
		if vrml_name.find(string[pos]) > -1:
			if end > 0:
			 start = pos
		if start >= 0 and end > 0 and vrml_name.find(string[pos]) == -1:
			sname = string[start:end]
			break
		else: pos -= 1
	#print 'sname:',sname
	pos -=1

	if sname == 'geometry':
		return ['geometry',key, name, 0, 'parent']
	if usedef == 'geometry':
		#raw_input()
		return ['geometry',key,name,1,'parent']
	if name == 'USE':
		print [usedef,key, 1,''], 'USE'
		#raw_input()
		return [usedef,key, 1,'']		#[type of the shape etc, name of the shape, 1 (means it has to be linked to the previous object)]
	if usedef == 'DEF':
		return [key,name,0,'']
	else:
		return [key,'',0,'']					#[material,shape, '', 0 (has to be created)]

def getCloseBrace(string, brace):			#first character of the string is a brace!
	#print 'searching for closeBrace...'
	#print string[:10]
	#raw_input()
	if brace == '}':
		brace2 = '{'
	if brace == ']':
		brace2 = '['
	position = 0
	counter = 0
	for char in string:
		position += 1
		if char == brace2:
			counter += 1
		if char == brace:
			counter -= 1
		if counter == 0:
			#print string[position-1	]
			return (position-1)
	#print 'No closing brace found: ',position, string[position-100:position]

def findFloat(string):
	#print string
	float_char = '-.0123456789'
	floatret = ''
	found = -1
	for n in string:
		if  float_char.find(n)> -1:
			#print 'float_char found', n
			floatret = floatret+n
			found = 1
		if found == 1 and float_char.find(n)<0:
			break
		#print floatret
	if found == 1: return floatret

###SWITCH FUNCTIONS ###


def switchNodeFunction(node,string,name='name',parent='parent'):					#link to funktions for nodes, such as worldInfo
	print node
	#raw_input()
	if node != None:
		if node[2][0] == 'ImageTexture':
			#print 'ImageTexture found!!!'
			#print name,parent
			#raw_input()
			setImageTexture(string[node[0]:node[1]],node[2][1], name)
		if node[2][0] == 'Transform':
			doTransform(string[node[0]:node[1]],node[2][1],parent)
		if node[2][0] == 'Group':
			defGroup(string[node[0]:node[1]])
		elif node[2][0] == 'WorldInfo':
			getWorldInfo(string[node[0]:node[1]])
		elif node[2][0] == 'NavigationInfo':
			getNavigationInfo(string[node[0]:node[1]])
		elif node[2][0] == 'Switch':
			getSwitch(string[node[0]:node[1]],parent)
		elif node[2][0] == 'Shape':
			getShape(string[node[0]:node[1]],name)
		elif node[2][0] == 'Appearance':
			getAppearance(string[node[0]:node[1]],parent)
		elif node[2][0] == 'Material'or node[2][0] == 'material':
			defMaterial(string[node[0]:node[1]], node[2][-2], node[2][-3], parent)
		elif node[2][0] == 'geometry':
			print 'geometry found!!!!!'
			defGeometry(string[node[0]:node[1]], node[2][1],node[2][2], node[2][3], node[2][4])

def switchListFunction(node,string,name = "None",ident = 0):					#link to function for lists, such as coordinate lists...
	print 'node:',node
	if node[2][0] == 'choice':
		getChoice(string[node[0]:node[1]])

def switchMaterialKeys(key, floats, matname):
	#print 'Material', matname, 'will be changed'
	mat = Material.Get(matname)
	if key == None:
		print 'error in switchMaterialKey'
		raw_input()
		return
	elif key == 'diffuseColor':
		print key, 'set with', floats
		mat.rgbCol = floats
	elif key == 'specularColor':
		print key, 'set with', floats
		mat.setSpecCol(floats)
	elif key == 'emissiveColor':
		print key, 'set with', floats
		mat.setEmit(averageValue(floats))
	elif key == 'shininess':
		print key, 'set with', floats
		mat.setHardness(int(floats[0]*255))
	elif key == 'transparency':
		print key, 'set with', floats
		mat.setAlpha(1-floats[0])
	elif key == 'ambientIntensity':
		print key, 'set with', floats
		mat.setAmb(floats[0])
	else:
		print 'no Material key found for: ', key
		raw_input()

def switchGeometryKeys(string,key, geomname,usedef = 0,parent = ''):
	if key == None:
		print 'error in switchGeometryKeys'
		raw_input()
		return
	if key == 'IndexedFaceSet':
		createIndexedFaceSet(string, geomname, parent)
	if key == 'Coordinate':
		createCoordinates(string,geomname,usedef, parent )
	if key == 'coordIndex':
		createFaces(string,geomname,0,parent)
	if key == 'Normal':
		createNormals(string,geomname,0,parent)
	if key == 'texCoord':
		print 'textCoord'
		raw_input()
		return createUVCoordinates(string,geomname,0,parent)
	if key == 'texCoordIndex':
		print 'textCoordIndex'
		raw_input()
		return createFaceList(string,geomname,0,parent)

###CREATE FUNKTIONS ###
def createIndexedFaceSet(string, geomname,parent = ''):
	print 'creating IndexedFaceSet:', geomname
	texCoord = []
	texIndex = []
	#me = NMesh.GetRaw(getNewName(geomname))
	#ob = Object.New('Mesh',geomname)
	#geomname = Mesh.getName()
	#ob.link(Mesh)
	#NMesh.PutRaw(Mesh, geomname)
	#raw_input()
	#if position > len(string) or openb == 0:
		#break
	#node = findNode(string,'}')
	#print node[2]
	#raw_input()
	#switchGeometryKeys(string[node[0]:node[1]],node[2][0],geomname,node[2][2])
	#if node != None:
	#	string = string[node[1]+1:]

	####Blenderanweisungen zum Erstellen einer Mesh
	while 1:
		key = findKey(string)
		print key
		if key != None:
			if key[0] == 'normalPerVertex':
				bool = findBool(string,key[1]+1)
				end = bool[1]
				print 'normalPerVertex option set to',bool,'in',geomname
				string = string[end+1:]
			elif key[0] == 'convex':
				bool = findBool(string,key[1]+1)
				#print bool
				end = bool[1]
				print 'convex option set to',bool,'in',geomname
				string = string[end+1:]
				#Blender anweisung zum setzen der Convex option (sofern vorhanden)
			elif key[0] == 'solid':
				bool = findBool(string,key[1]+1)
				end = bool[1]
				print 'solid option set to',bool,'in',geomname
				string = string[end+1:]
				#Blender anweisung zum setzen der solid option (sofern vorhanden)
			elif key[0] == 'coord':
				node = findNode(string,'}')
				switchGeometryKeys(string[node[0]:node[1]],node[2][0],node[2][1],node[2][2],geomname)
				if node != None:
					string = string[node[1]+1:]
				#Blenderanweisungen zum festlegen der Coordinaten in createCoordinates
			elif key[0] == 'coordIndex':
				node = findNode(string,']')
				switchGeometryKeys(string[node[0]:node[1]],'coordIndex',geomname,0,geomname)
				if node != None:
					string = string[node[1]+1:]
			elif key[0] == 'normalIndex':# or 'normal':
				node = findNode(string,']')
				switchGeometryKeys(string[node[0]:node[1]],'Normal',geomname,0,geomname)
				if node != None:
					string = string[node[1]+1:]
			elif key[0] == 'normal':
				node = findNode(string,'}')
				switchGeometryKeys(string[node[0]:node[1]],'Normal',geomname,0,geomname)
				if node != None:
					string = string[node[1]+1:]
			elif key[0] == 'texCoord':
				print key[0]
				raw_input()
				node = findNode(string,'}')
				texCoord = switchGeometryKeys(string[node[0]:node[1]],'texCoord',geomname,0,geomname)
				if node != None:
					string = string[node[1]+1:]
			elif key[0] == 'texCoordIndex':
				print key[0]
				raw_input()
				node = findNode(string,']')
				texIndex = switchGeometryKeys(string[node[0]:node[1]],'texCoordIndex',geomname,0,geomname)
				if node != None:
					string = string[node[1]+1:]
			else:
				print 'key', key, 'not found'
				raw_input()
				#break
		else:
			break
	if texIndex != [] and texCoord != []:
		print 'applying the texture coordinates'
		#for coord in texCoord:
			#for face in texIndex:
		print geomname
		me = NMesh.GetRaw(getNewName(geomname))
		#the texindex is not used at the moment, the uvs are ordered to the face at the same position in the list
		#not sure if that works anyway
		for face in me.faces:
			for coords in texCoord:
				face.uv = coords
		me.hasFaceUV(1)
		me.update()
		raw_input()



def createFaces(string,geomname,usedef = 0, parent = ''):
	#geomname nur interessant wenn verlinkt werden muss(keine ahnung wie das laufen soll)

	me = NMesh.GetRaw(getNewName(parent))
	#Mesh = NMesh.GetRaw(geomname)
	#raw_input()
	#for v in Mesh.verts:
		#print v
	face = []
	count = 0
	int_char = '-1234567890'
	intret = ''
	found = -1
	for n in string:
		if  int_char.find(n)> -1:
			#print 'float_char found', n
			intret = intret+n
			found = 1
		if found == 1 and int_char.find(n)<0:
			#print intret
			if int(intret) <0:
				face = NMesh.Face(face)
				me.faces.append(face)
				face = []
			else:
				face.append(me.verts[int(intret)])
			count += 1
			found = -1
			intret = ''
		#if tripel == []:
			#break
			#string = tripel[1]
				#print len(string)
			#raw_input()
	me.update()
	###It is possible, that the last face is missing, because it has not endet with a -1, checking not implemented yet

def createCoordinates(string,geomname,usedef=0, parent = ''):
	print geomname, parent
	#geomname nur interessant wenn verlinkt werden muss(keine ahnung wie das laufen soll)

	me = NMesh.GetRaw(getNewName(parent))
	print me,'############################'
	#Mesh = NMesh.GetRaw(parent)
	tripel = []
	count = 0
	float_char = '-1234567890.'
	floatret = ''
	found = -1
	for n in string:
		if  float_char.find(n)> -1:
			#print 'float_char found', n
			floatret = floatret+n
			found = 1
		if found == 1 and float_char.find(n)<0:
			tripel.append(float(floatret))
			count += 1
			found = -1
			floatret = ''
		#if tripel == []:
			#break
		if count > 2:
			#print 'setting Point at', tripel
			v = NMesh.Vert(tripel[0], tripel[1], tripel[2]) # create the NMVert
			me.verts.append(v)
			#Mesh.verts.append((tripel[0],tripel[1],tripel[2]))
			tripel = []
			count = 0
			#string = tripel[1]
				#print len(string)
			#raw_input()
	me.update()
	Redraw()
	#for v in Mesh.verts:
		#print v
	print 'ready'

def createUVCoordinates(string,geomname,usedef=0, parent = ''):
	print 'creating UV Coordinates'
	print parent
	raw_input()
	UVList = []
	tupel = []
	count = 0
	float_char = '-1234567890.'
	floatret = ''
	found = -1
	for n in string:
		if  float_char.find(n)> -1:
			#print 'float_char found', n
			floatret = floatret+n
			found = 1
		if found == 1 and float_char.find(n)<0:
			tupel.append(float(floatret))
			count += 1
			found = -1
			floatret = ''
		#if tripel == []:
			#break
		if count > 1:
			#print 'setting Point at', tripel
			UVList.append((tupel[0],tupel[1]))
			tupel = []
			count = 0
	return UVList

def createFaceList(string,geomname,usedef=0, parent = ''):
	print 'creating UV facelist'
	print parent
	facelist = []
	face = []
	count = 0
	int_char = '-1234567890'
	intret = ''
	found = -1
	for n in string:
		if  int_char.find(n)> -1:
			#print 'float_char found', n
			intret = intret+n
			found = 1
		if found == 1 and int_char.find(n)<0:
			#print intret
			if int(intret) <0:
				facelist.append(face)
				face = []
			else:
				face.append(int(intret))		###########################PROBLEM!!!!! NO MESH DEFINED
			count += 1
			found = -1
			intret = ''
	return facelist

def createNormals(string,geomname,usedef=0, parent = ''):
	pass # Normals are not applicable at the moment, Blender recalculates the Normals itself

def setImageTexture(string,name, parent):
	if name == '':
		name =  'texture'
	try:
		mat = Material.Get(parent)
		#me = ob.getData()
	except:
		print 'Material does not exist'
		return
	img = None
	pos1 = string.find('"')
	pos2 = string[pos1+1:].find('"')+pos1+1
	image = string[pos1+1:pos2]
	print image
	try:
		img = Image.Load(image) # load the image from disk
	except:
		print "couldn't load image"
	try:
		tex = Texture.New()
	except: return
	tex.setType('Image')
	tex.image = img
	mat.setTexture(0,tex)
	#if img:
		#for f in me.faces:
			#f.image = img

###DEF FUNKTIONS (use included###

def defGroup(string):
	print 'creating Group'
	#print string
	#raw_input()
	members = []
	node = findNode(string,']')
	switchNodeFunction(node,string)
	string = string[node[0]:node[1]]
	while 1:
		node = findNode(string,'}')
		print node
		switchNodeFunction(node,string)
		if node != None:
			members.append(node[2][1])
			string = string[node[1]+1:]
		else: break
	print members
	for m in members:
		try:
			ob1 = Object.Get(getNewName(m))
			break
		except: pass
	for m in members:
		try:
			ob2 = Object.Get(getNewName(m))
		except: pass
		try:
			ob1.makeParent([ob2])
		except: pass



def doTransform(string, name, parent):
	print name, parent, '\n'
	rotation = [0,0,0]
	scale = [1,1,1]
	translation = [0,0,0]
	try:
		ob = Object.Get(getNewName(name))
	except:
		ob = Object.New('Mesh',name)
		setNewName(name,ob.getName())
	name = getNewName(name)
	while 1:
		key = findKey(string)
		#print key
		if key != None:
			if key[0] == 'translation':
				values = getValues(string[key[1]+1:],3)
				translation = values[1]
				print translation
				string = values[0]
			elif key[0] == 'rotation':
				values = getValues(string[key[1]+1:],4)
				rotation = values[1]
				string = values[0]
			elif key[0] == 'scale':
				values = getValues(string[key[1]+1:],3)
				scale = values[1]
				print scale
				string = values[0]
			elif key[0] == 'scaleOrientation':
				values = getValues(string[key[1]+1:],4)
				scaleOrient = values[1]
				string = values[0]
			elif key[0] == 'children':
				string = string[key[1]:]
				while 1:
					#key = findKey(string)
					node = findNode(string,'}')
					switchNodeFunction(node,string,name)
					if node != None:
						string = string[node[1]+1:]
					else: break
					#string = string[key[1]:]
			else: break
		else:
			#print 'error in doTransform!!!'
			#raw_input()
			break
	ob.setLocation(float(translation[0]),float(translation[1]),float(translation[2]))
	#raw_input()
	ob.setEuler(float(rotation[0]),float(rotation[1]),float(rotation[2]))
	#print 'new rot:', rotation
	ob.SizeX *= float(scale[0])
	ob.SizeY *= float(scale[1])
	ob.SizeZ *= float(scale[2])
	print scale
	print 'SIZE', ob.SizeX,ob.SizeY,ob.SizeZ
	#raw_input()





def defMaterial(string, ident, matname = None, parent = None):
	print 'defining Material'
	if matname != '':
		try:
			mat = Material.Get(matname)
		except:
			print 'creating Material', matname
			mat = Material.New(matname)
			setNewName(name,me.name)
	else :
		print 'creating Material without name'
		mat = Material.New()
	matname = mat.getName()


	if int(ident) == 0:
		#find Material options
		def findMatKeys(string):
			keys = []
			pos = 0
			start = -1
			end = -1
			for c in string:
				#print pos
				if ascii_letters.find(c) > -1:
				#print string[pos]
					if start < 0:
						start = pos
					if start > 0:
			 			end = pos+1
				if start >= 0 and end > 0 and ascii_letters.find(c) == -1:
					#print string
					keys.append([string[start:end], start])
					start = -1
					end = -1
				pos += 1
			return keys

		keys = findMatKeys(string)
		#print keys
		pos = 0
		while 1:
			if keys == []:
				break
			floats = []
			if keys[pos][0] != keys[-1][0]:
				floatstring = string[keys[pos][1]:keys[pos+1][1]]
				while 1:
					floatnumber = findFloat(floatstring)
					if floatnumber:
						floats.append(float(floatnumber))
						floatstring = deleteString(floatstring, floatnumber)
					else: break
				switchMaterialKeys(keys[pos][0], floats, matname)
				pos +=1
			else:
				floatstring = string[keys[pos][1]:]
				while 1:
					floatnumber = findFloat(floatstring)
					if floatnumber:
						floats.append(float(floatnumber))
						floatstring = deleteString(floatstring, floatnumber)
					else: break
				switchMaterialKeys(keys[pos][0], floats, matname)
				break


		#if parent != '':
			#print 'linking material to object',parent
			#ob = Object.Get(parent)
			#ob.link(mat)
	else:		#Material has to be linked to an object
		print 'linking ',matname,' to object',parent
		ob = Object.Get(parent)
		me = ob.getData()
		try:
			me.addMaterial(mat)
		except:
			pass
		me.update()


def defGeometry(string,key,name, ident, parent):
	#return ['geometry',key, name, 1, 'parent']
	print 'defGeometry',key,name,ident,parent
	#raw_input()
	if ident == 0:
		me = NMesh.New(name)
		setNewName(name,me.name)
		name = getNewName(name)
		me.update()
		switchGeometryKeys(string,key, name, parent)
	else:
		print 'linking geometry'
		ob = Object.Get(getNewName(parent))
		me = NMesh.GetRaw(getNewName(name))
		oldMesh = ob.getData()
		me.materials = oldMesh.materials
		#destroy(oldMesh)
		del oldMesh
		ob.link(me)
		me.update()
		scene = Scene.GetCurrent()
		try:
			scene.link(ob)
		except: pass
		Redraw()
	#while 1:
		#node = findNode(string,'}')
		#if node == None:
			#break
		#createFunction(node,string)
		#if node != None:
			#string = string[node[1]+1:]


###NODE FUNKTIONS ###

def getWorldInfo(string):
	print 'creating WorldInfo...'


def getNavigationInfo(string):
	print 'creating NavigationInfo...'

def getSwitch(string,parent):
	print 'creating switch...'
	while 1:
		if string.find('whichChoice') > -1:			#not really necessary at the moment
			pass
		node = findNode(string,']')
		if node == None:
			break
		switchListFunction(node,string,'',parent)
		string = string[node[1]+1:]

def getShape(string,parent):
	print 'creating shape...'
	#raw_input()
	while 1:
		key1 = findKey(string)
		if key1 == None:
			break
		key2 = findKey(string[key1[1]:])
		if key2[0] == 'USE':
			key3 = findKey(string[key2[1]+key1[1]:])
			switchNodeFunction([0,0,[key1[0],key1[0],key3[0],1,parent]],'',key3[0],parent)
			string = string[key3[1]+key2[1]+key1[1]:]
		else:
			node = findNode(string,'}')
			if node == None:
				break
			switchNodeFunction(node,string,'',parent)
			string = string[node[1]+1:]

def getAppearance(string,parent):
	print 'creating Appearance...'
	material = ''
	while 1:
		key1 = findKey(string)
		#print 'key1:', key1
		if key1 == None:
			break
		key2 = findKey(string[key1[1]:])
		#print 'key2:',key2
		if key2[0] == 'USE':
			key3 = findKey(string[key2[1]+key1[1]:])
			#print 'key3:',key3
			material = key3[0]
			#print [key1[0],key1[0],key3[0],1,parent],'',key3[0],parent
			switchNodeFunction([0,0,[key1[0],key1[0],key3[0],1,parent]],'',key3[0],parent)
			#print 'vorher',string, '\n'
			string = string[key3[1]+key2[1]+key1[1]:]
			#print 'nachher',string
		else:
			node = findNode(string,'}')
			if node == None:
				break
			switchNodeFunction(node,string,material,parent)
			string = string[node[1]+1:]
###LIST FUNCTIONS ###

def getChoice(string):
	while 1:
		node = findNode(string,'}')
		if node == None:
			break
		switchNodeFunction(node,string)
		if node != None:
			string = string[node[1]+1:]


### MAIN CODE ###


file = open("/zgdv/distel/home/fschaar/VRML/3dsmax_sphere_01.wrl",'r')#Maya_sphere_01.wrl", 'r')
string = file.read()
file.close()
string = killComments(string)
file = open('withoutcomments.wrl','w')
file.write(string)
position = 0

while 1:
	#print string
	openb = 0
	closeb = 0
	for char in string:
		if char == '{': openb += 1
		if char == '}': closeb += 1
	if position > len(string) or openb == 0:
		break
	node = findNode(string,'}')
	switchNodeFunction(node,string)
	if node != None:
		string = string[node[1]+1:]

print 'finished'
