from string import *
class vrml_analyse:

	def __init__(self,vrml_file):
		#[ "Anchor","Appearance","Anchor","AudioClip","Background", "Billboard", "Box", "Collision", "Color","ColorInterpolator",  "Cone", "Coordinate", "CoordinateInterpolator", "Cylinder","CylinderSensor", "DirectionalLight", "ElevationGrid","Extrustion", "Fog", "FontStyle", "Group","ImageTexture", "IndexedFaceSet", "IndexedLineSet", "Inline", "LOD","Material", "MovieTexture", "NavigationInfo", "Normal", "NormalInterpolator","OrientationInterpolator", "PixelTexture","PlaneSensor", "PointLight", "PointSet", "PositionInterpolator", "ProxmimitySensor", "ScalarInterpolator", "Script", "Shape", "Sound", "Sphere", "SphereSensor", "SpotLight", "Switch", "Text", "TextureCoordinate", "TextureTransform", "TimeSensor", "TouchSensor", "Transform", "Viewpoint", "VisibilitySensor", "WorldInfo"]
		file = open(vrml_file,'r')
		self.string = file.read()


	def getValues(self,string,number):
		''' returns the floatvalues within a given String
		and returns the values and the string without the values
		VERY SLOW CAN BE BETTER WIT A FOR LOOP'''
		values = []
		c = 0
		while c < number:
			f = self.findFloat(string)
			values.append(f)
			string = self.deleteString(string,f)
			c += 1
		return values


	def findFloat(self,string):
		'''returns a float value from a given string
		MAY BE INTEGRATED IN getValues, FOR SPEED PURPOSE'''
		float_char = '-0123456789'
		floatret = ''
		found = -1
		for n in string:
			if  float_char.find(n)> -1:
				floatret = floatret+n
				float_char = float_char+'.e'
				found = 1
			elif found == 1 and float_char.find(n)<0:
				break
		if found == 1: return floatret


	def deleteString(self,string, delete):
		'''string without delete will be returned'''
		#print string[:50], '\n\n', delete
		poss = 0
		posd = 0
		firstpos = -1
		while 1:
			if len(delete) == 0:
				return string
			#if string.find(delete) < 1:
				#pass
			if string[poss]== delete[posd]:
				if posd == 0:
					firstpos = poss
				posd += 1
				if posd == len(delete):
					return string[:firstpos]+string[poss+1:]
			else:
				if posd > 0:
					poss = firstpos
					posd = 0
			poss +=1

	def findKey(self,string):
		'''returns the first key found in the stringand its start and end position
		CHANGE TO RETURN ALL KEYS FROM A POSSIBLE KEYLIST; WITH  ENCLOSED STRING'''
		keys = []
		pos = 0
		start = -1
		end = -1
		keyletters = ascii_letters+'_-0123456789'			#optionaly maybe also "." for sensors
		for c in string:
			#print pos
			if keyletters.find(c) > -1:
				#print string[pos]
				if start < 0:
					start = pos
				if start > 0:
		 			end = pos+1
			if start >= 0 and end > 0 and keyletters.find(c) == -1:
				#print string
				return [string[start:end], end]
			pos += 1

	def getKeyList(self,string):
		'''returns a list, containing a key which is also in the keylist
		together with the string belonging to it
		Keyword is only found, when it starts with a space character!!!!'''
		pos = 0						#records the current string position
		start = -1				#starting point of a possible key string
		sstart = 0				#starting point of the string area belonging to the key
		end = -1					#end point of a possible key string
		state = 0					#different find options: 0,1 = searching for key 1= searching for brace 2 = searching for closing brace
		o_brace ='{'			#saves the type of brace following the key, can be '{' and '['
		c_brace = '}'			#saves the closin brace belonging to o_brace: '}' and ']'
		bracecount = 0		#counts the relationship between open an closed braces
		key = ''					#saves the key, until the next or a brace-space is found
		keyletters = ascii_letters+'_-0123456789'			#optionaly maybe also "." for sensors
		keys = []
		#there are two types of key: those wit a brace space and those without
		#for each key everything from the last key (or last closing brace)
		#till the next key or next closing brace is saved in the string
		#(to make sure we have everything belonging to this key)
		#it will be analysed in more detail later
		#this is just to get all keys with its components
		for s in string:
			if bracecount == 0 and state != 2:										#just search for keys while no openeing brace was found
				if keyletters.find(s) > -1:					#find a word
				#print string[pos]
					if start < 0:
						start = pos
					if start > 0:
						end = pos+1
				if start >= 0 and end > 0 and keyletters.find(s) == -1:			#a complete word was found
					if self.VRMLReserved.count(string[start:end]) > 0:					#check if its a key
						if state == 1:									#there may be a key which is not saved because it has no braces
							keys.append([key,sstart,start-1])	#save last key with possible string space
							sstart = sstart+len(key)+1				#make new starting point for next keyspace
						key = string[start:end]							#get new key
						state = 1					#we have a key
					start = -1					#new keys will be found
					end = -1
			if state == 1:					#we are ready to search for a brace/braket
				if s == '{':					#if we find one only need the closing on
					o_brace = '{'				#no keys are accepted during state 2
					c_brace = '}'
					state = 2
					bracecount += 1
				elif s == '[':				#brakets are handled the same way here
					o_brace = '['
					c_brace = ']'
					state = 2
					bracecount += 1
			elif state == 2:					#searching for the close brace/braket
				if s == o_brace:
					bracecount += 1			#one more obening brace
				elif s == c_brace:
					bracecount -= 1			#one closing brace, but maybe not the last one
				if bracecount == 0:		#last closing brace found
					state = 0						# return to state 0
					keys.append([key,sstart,pos+1])		#and save key with stringspace (including braces)
					sstart = pos+1		#next string space will start after the closing brace
			pos += 1							#increment position in main string
		if state == 1:									#there may be a key which is not saved because it has no braces
			keys.append([key,sstart,start-1])	#save last key with possible string space
		return keys




	def getCloseBrace(self,string, brace):			#first character of the string is a brace!
		'''finds the closing brace given in brace
		HAS TO BE CHECKED'''
		if brace == '}':
			brace2 = '{'
		if brace == ']':
			brace2 = '['
		position = 0
		counter = 0
		for char in string:
			position += 1
			if char == brace2:
				counter += 1
			if char == brace:
				counter -= 1
			if counter == 0:
				return (position-1)

	def getBracespace(self,string):			#first character of the string is a brace!
		'''finds the string from the next brace or bracet ('{' or '[') 
		till its corresponding closing pendant'''
		#print string[:50], '\n\n', string[-10:]
		state = 0
		pos = 0
		count = 0
		start = -1
		for char in string:
			if state == 0:
				if char == '{':
					brace = '{'
					brace2 = '}'
					state = 1
					start = pos
					count = 1
				elif char == '[':
					brace = '['
					brace2 = ']'
					state = 1
					start = pos
					count = 1
			else:
				if count == 0:
					return [start,pos+1]
				elif char == brace:
					count += 1
				elif char == brace2:
					count -= 1
			pos += 1
		if start == -1:
			return 0
		if count == 0:
			return [start,pos+1]
		return 0
	'''
	def getName(self,string):
		print string
		pos = 0
		start = -1
		end = -1
		nameletters = ascii_letters+'_-0123456789'
		for c in string:
			if nameletters.find(c) > -1:
				if start < 0:
					start = pos
				if start > 0:
					end = pos+1
			if start >= 0 and end > 0 and nameletters.find(c) == -1:
				return string[start:end]
			pos += 1
		if start >= 0:
			return string[start:pos]
		return None
	'''

	def getName(self,string):
		nameletters = ascii_letters+'_-0123456789'
		name = ''
		found = -1
		for n in string:
			if  nameletters.find(n)> -1:
				name = name+n
				found = 1
			if found == 1 and nameletters.find(n)<0:
				break
		if found == 1: return name


	def start(self,string, parent = 'parent'):
		self.keys = self.getKeyList(string)
		self.switchFunctions(string, parent)

	def splittString(self,string):
		'''returns a list of two strings, one with the key part
		and the other wit the brace/bracket part
		if there are no braces, the given string will be returned'''
		string2 = self.getBracespace(string)
		if string2 == 0:
			return [string]
		else:
			return [string[:string2[0]-1],string[string2[0]:string2[1]]]

