from string import *
from vrml_analyse import *
from Blender import *



def getName(string):
	nameletters = ascii_letters+'._-0123456789'
	name = ''
	found = -1
	for n in string:
		if  nameletters.find(n)> -1:
			name = name+n
			found = 1
		if found == 1 and nameletters.find(n)<0:
			break
	if found == 1: return name

def killComments(string):
	'''deletes all lines from # till eol
	and returns the string without comments
	ALSO KILLS "COMMENTS" WITHIN QUOTATION MARKS!!! HAS TO BE CORRECTED'''
	pos = 0
	pos1 = -1
	pos2 = -1
	length = len(string)
	while pos < length:
		if string[pos] == '#':
			pos1 = pos
		if pos1 >= 0 and string[pos] == '\n':
			pos2 = pos
			pos = pos1-1
			string = string[:pos1]+string[pos2+1:]
			length = len(string)
			pos1 = -1
		pos += 1
	print 'Comments killed!'
	return string

def averageValue(liste):
	'''comutes and returns the average value,
	from the values given in the list'''
	c = 0
	sum = 0
	for v in liste:
		sum += v
		c += 1
	return sum/c

def setNewName(oldname,newname):
	'''if new names are assigned by Blender,
	because an object with that name already exists,
	the new name is stored into namelist, because it is not changed
	in the VRML file but could be used later'''
	file = open('aliasnames', 'a')
	if oldname != newname:
		file.write(oldname+ '='+newname+'\n')
		#namelist[oldname]= newname


def getNewName(name):
	'''returning the new name of the object
	in most cases it is the original name'''
	file = open('aliasnames', 'r')
	string = file.read()
	while 1:
		pos = string.find(name)
		#print pos
		#print string[pos:]
		if pos <0 :
			return name
		if (pos+len(name)) < len(string):
			if string[(pos+len(name))] != '=':
				string = string[pos+len(name):]
			else:
				break
		else:
			return name
	string = string[pos+len(name):]
	return getName(string)
