from vrml_analyse import *

class vrml_interpolator(vrml_analyse):

	def __init__(self,string,parent):
		self.VRMLReserved= ["set_fraction", "key", "keyValue", "value_changed"]
		self.keys = []
		self.string = string
		self.parent = parent


def setInterpolator(self):
		'''gets Interpolator nodes and hands them to the corresponding functions'''
		#print '###'+self.string[:50]+'\n'+self.string[-50:]+'###'
		self.string = self.splittString(self.string)		#
		namestring = self.string[0]
		breaker = 0
		#print 'namestring:',namestring
		while 1:
			name = self.getName(namestring)
			#print 'name',name
			if name == None:
				print 'no Interpolation defined!'
				return
			elif name == 'DEF':
				breaker = 1
			elif name == 'USE':
				breaker = -1
			elif breaker == -1:
				#link ipo to parent
				return
			elif breaker == 1:
				iponame = name
				breaker = 2
			elif name == 'Positioninterpolator'
				or name == 'Orientationinterpolator'
				or name == 'Colorinterpolator'
				or name == 'Scaleinterpolator'
				or name == 'Coordinatinterpolator'
				or name == 'Normalinterpolator':
				ipotype = name
				break
			namestring = self.deleteString(namestring, name)
		self.keys = self.getKeyList(self.string[1][1:-1])								#get the keys within the braces
		retkeys = self.switchFunctions(self.string[1][1:-1], self.parent)
		keys = retkeys[0]
		keyvalues = []
		rangecount = len(retkeys[1])/len(keys)
		for key in range(keys):
			keyvalues.append([])
			while count < range(rangecount):
				keyvalues[key].append(retkeys[1].pop())
		if ipotype == 'Positioninterpolator':
			self.createPositionIpo(keys,keyvalues, parent)
		elif ipotype == 'Orientationinterpolator':
			self.createOrientationIpo(keys,keyvalues, parent)
		elif ipotype == 'Colorinterpolator':
			self.createColorIpo(keys,keyvalues, parent)
		elif ipotype == 'Scaleinterpolator':
			self.createScaleIpo(keys,keyvalues, parent)
		elif ipotype == 'Coordinateinterpolator':
			self.createCoordinateIpo(keys,keyvalues, parent)
		elif ipotype == 'Normalinterpolator':
			self.createNormalIpo(keys,keyvalues, parent)




	def switchFunctions(self,string, parent):
		for key in self.keys:
			if key[0] == "set_fraction":
				self.set_fraction(string,parent)
			elif key[0] == "key":
				keys = self.key(string,parent)
			if key[0] == "keyValue":
				keyValues = self.keyValue(string,parent)
			elif key[0] == "value_changed":
				self.value_changed(string,parent)
			else:
				print 'key not found', key[0], 'in vrml_interpolator'
		return [keys,keyValues]



	def set_fraction(self,string,parent):
		pass
	def key(self,string,parent):
		values = []
		float_char = '-1234567890.'
		floatret = ''
		found = -1
		for n in string:
			if  float_char.find(n)> -1:
				floatret = floatret+n
				found = 1
			if found == 1 and float_char.find(n)<0:
				#print floatret
				values.append(float(floatret))
				found = -1
				floatret = ''
		return values

	def keyValue(self,string.parent):
		return self.key(string,parent)

	def value_changed(self,string.parent):
		pass

	def createPositionIpo():
		pass