from vrml_analyse import *

class vrml_bindables(vrml_analyse):
	def set_bind(self,string,parent):
		pass
	def isBound(self,string.parent):
		pass


class vrml_viewpoint(vrml_bindables):

	def __init__(self,string,parent):
		self.VRMLReserved= ["set_bind", "isBound", "fieldOfView", "jump", "orientation", "position", "description", "bindTime"]
		self.keys = []
		self.string = string
		self.parent = parent

	def set_bind(self,string,parent):
		pass
	def isBound(self,string, parent):
		pass
	def fieldOfView(self,string,parent):
		pass
'''
		processes the children nodes
		#print 'children'
		#print '##',string[:50], '\n\n', string[-10:], '##'
		for c in string:
			if c =='[':
				string = self.splittString(string)[1][1:-1]		#take the bracket string without the brackets
				break
			if c =='{':
				try: #string = self.deleteString(string, 'children')
					string = string[(string.find('children')+8):]
				except: pass
				break
		keys = self.getKeyList(string)
		self.switchFunctions(string, parent, keys)
'''
	def jump(self,string,parent):
		pass
	def orientation(self,string,parent):
		pass
	def position(self,string,parent):
		pass
	def description(self,string,parent):
		pass
	def bindTime(self,string,parent):
		pass
	def setViewpoint():
	
	def switchFunctions(self,string, parent, keys = None):
		if keys == None:
			keys = self.keys
		for key in keys:
			if key[0] == "set_bind":
				self.set_bind(string[key[1]:key[2]], parent)
			elif key[0] == "isBound":
				self.isBound(string[key[1]:key[2]], parent)
			elif key[0] == "fieldOfView":
				self.fieldOfView(string[key[1]:key[2]], parent)
			elif key[0] == "jump":
				self.jump(string[key[1]:key[2]], parent)
			elif key[0] == "orientation":
				self.orientation(string[key[1]:key[2]], parent)
			elif key[0] == "position":
				self.position(string[key[1]:key[2]], parent)
			elif key[0] == "description":
				self.description(string[key[1]:key[2]], parent)
			elif key[0] == "bindTime":
				self.bindTime(string[key[1]:key[2]], parent)

class vrml_background(vrml_bindables):

	def __init__(self,string,parent):
		self.VRMLReserved= ["set_bind", "isBound", "groundAngle", "groundColor", "backUrl", "bottomUrl", "leftUrl", "rightUrl", "topUrl", "skyAngle", "skyColor" ]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_fog(vrml_bindables):

	def __init__(self,string,parent):
		self.VRMLReserved= ["set_bind", "isBound", "color", "fogType", "visibilityRange"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_navigationinfo(vrml_bindables):

	def __init__(self,string,parent):
		self.VRMLReserved= ["set_bind", "isBound", "avatarSize", "headlight", "speed", "type", "visibilityLimit"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_worldinfo(vrml_bindables):

	def __init__(self,string,parent):
		self.VRMLReserved= ["info", "title"]
		self.keys = []
		self.string = string
		self.parent = parent
