from vrml_analyse import *

class vrml_sensor(vrml_analyse):
	def enabled(self,string,parent):
		pass
	def isActive(self,string.parent):
		pass


class vrml_touchsensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "hitNormal_changed", "hitPoint_changed","hitTexCoord_changed", "isOver", "touchTime"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_planesensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "autoOffset", "maxPosition","minPosition", "offset", "trackPoint_changed", "translation_changed"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_cylindersensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "autoOffset", "diskAngle","maxAngle", "minAngle", "offset", "rotation_changed", "trackPoint_changed"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_spheresensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "autoOffset",  "offset", "rotation_changed", "trackPoint_changed"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_proximitysensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "center", "size","position_changed", "orientation_changed", "enterTime", "exitTime"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_visibilitysensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "center", "size", "enterTime", "exitTime"]
		self.keys = []
		self.string = string
		self.parent = parent


class vrml_timesensor(vrml_sensor):

	def __init__(self,string,parent):
		self.VRMLReserved= ["enabled", "isActive", "cycleInterval", "loop","startTime", "stopTime", "cycleTime", "fraction_changed", "time"]
		self.keys = []
		self.string = string
		self.parent = parent
